"""
# Test PortalTaxonomy.py
"""

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from Products.CMFPlone.tests import PloneTestCase

ZopeTestCase.installProduct('PortalTransforms')
ZopeTestCase.installProduct('Archetypes')
ZopeTestCase.installProduct('MimetypesRegistry')
ZopeTestCase.installProduct('PortalTaxonomy')

class TestPortalTaxonomy(PloneTestCase.PloneTestCase):

    def afterSetUp(self):
        self.qi = self.portal.portal_quickinstaller
        self.qi.installProducts(['PortalTaxonomy',])
        self.pc = self.portal.portal_categories
        self.pa = self.portal.portal_attributes

    def testAddCategory(self):
        ''' Test that a category can be added
        '''
        self.pc.invokeFactory('Category', id='c1', title='C 1')
        self.assertEqual(self.pc['c1'].title, 'C 1')

    def testAddSubCategory(self):
        ''' Test that a sub category can be added
        '''
        self.pc.invokeFactory('Category', id='p1', title='Parent 1')
        self.assertEqual(self.pc['p1'].title, 'Parent 1')
        self.pc['p1'].invokeFactory('Category', id='c1', title='Child 1')
        self.assertEqual(self.pc['p1']['c1'].title, 'Child 1')

    def testAddAttributeCollection(self):
        ''' Add an attribute collection
        '''
        self.pa.invokeFactory('AttributeCollection',id = 'ac1', title = 'AC 1')
        self.assertEqual(self.pa['ac1'].title, 'AC 1')

    def testAddAttribute(self):
        ''' Add an attribute to an attribute collection
        '''
        self.pa.invokeFactory('AttributeCollection',id = 'pac1', title = 'AC 1')
        self.assertEqual(self.pa['pac1'].title, 'AC 1')
        self.pa['pac1'].invokeFactory('Attribute', id = 'a1', title = 'A 1')
        self.assertEqual(self.pa['pac1']['a1'].title, 'A 1')

def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestPortalTaxonomy))
    return suite

if __name__ == '__main__':
    framework()
